--
-- CombineFillLevelWarnings (CoFiLeWa)
-- fillLevel warnings for combines (acoustic and visual signals) 
--
-- Version: 1.5
-- Author: gotchTOM
-- Date: 30-Apr-2017
--

CoFiLeWa = {};

local mod_directory = g_currentModDirectory;

function CoFiLeWa.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Combine, specializations);
end;

function CoFiLeWa:load(savegame)
	self.bLiActive = false;
	self.warnSigActiv = false;
	local coFiLeWaSoundFile = Utils.getFilename("CombineFillLevelWarnings/peep.wav", mod_directory);	
  self.coFiLeWaSoundId = createSample("coFiLeWaSound");
  loadSample(self.coFiLeWaSoundId, coFiLeWaSoundFile, false);
end;

function CoFiLeWa:delete()
end;

function CoFiLeWa:mouseEvent(posX, posY, isDown, isUp, button)
 end;
 
function CoFiLeWa:keyEvent(unicode, sym, modifier, isDown)
 end;
 
function CoFiLeWa:update(dt)
end;

function CoFiLeWa:updateTick(dt)
	if self:getIsActive() then
		local rootVehicle = self:getRootAttacherVehicle();
		local fillLevelInformations = {}; --changed for LS17
		if rootVehicle.getFillLevelInformation ~= nil then
			rootVehicle:getFillLevelInformation(fillLevelInformations);
			local fillLevel = 0;
			local capacity = 0;
			for i,fillLevelInformation in pairs(fillLevelInformations) do
				if fillLevelInformation.capacity > 0 then
					fillLevel = fillLevel + fillLevelInformation.fillLevel;
					capacity = capacity + fillLevelInformation.capacity;
				end;	
			end;
			if fillLevel > 0 then
				if not self.bLiActive then
					if fillLevel >= 0.8 * capacity then
						if not rootVehicle.beaconLightsActive then
							rootVehicle:setBeaconLightsVisibility(true);
						end;
						if self:getIsActiveForSound() then
							playSample(self.coFiLeWaSoundId, 1, 1, 0);
						end;	
						self.bLiActive = true;		
					end;
				else
					if fillLevel < 0.8 * capacity then
						local rootVehicle = self:getRootAttacherVehicle();
						if rootVehicle.beaconLightsActive then
							rootVehicle:setBeaconLightsVisibility(false);
						end;
						self.bLiActive = false;	
					end;
				end;
				if self:getIsActiveForSound() then
					if not self.warnSigActiv then	
						if fillLevel >= 0.99 * capacity then
							playSample(self.coFiLeWaSoundId, 1, 1, 0);
							self.warnSigActiv = true;
						end;	
					else		
						if fillLevel < 0.99 * capacity then
							self.warnSigActiv = false;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function CoFiLeWa:onLeave()
	self.bLiActive = false;	
end;

function CoFiLeWa:draw()
end;