--[[
ReelAutoHeight


Version: 	2.1.1
Author:	 	gotchTOM
Date: 		9-Mar-2017

]]--

ReelAutoHeight = {};

function ReelAutoHeight.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Cutter, specializations);
end;

function ReelAutoHeight:load(savegame)
	self.reelAutoHeightFirstRun = true;
end;

function ReelAutoHeight:delete()
end;

function ReelAutoHeight:readStream(streamId, connection)
end;

function ReelAutoHeight:writeStream(streamId, connection)
end;

function ReelAutoHeight:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ReelAutoHeight:keyEvent(unicode, sym, modifier, isDown)
end;

function ReelAutoHeight:update(dt)
end;

function ReelAutoHeight:updateTick(dt)

	if self:getIsActive() then
    if self.isClient then
			if self.reelAutoHeightFirstRun then
					if self.movingTools ~= nil then
						self.rotMovingTools = {};
						for i=1, table.getn(self.movingTools) do
							local tool = self.movingTools[i];
							local reelAxis;
							if tool ~= nil and tool.axis ~= nil then
								reelAxis = string.find(tool.axis,"REEL")
							end;
							if tool.rotSpeed ~= nil and tool.curRot[tool.rotationAxis] ~= nil and reelAxis ~= nil then
								local rotTool = {};
								rotTool.desiredTargetRot = tool.curRot[tool.rotationAxis];
								if rotTool.moveDownRot == nil then
									if tool.startRot == tool.rotMax then
										rotTool.moveDownRot = "rotMin";
									elseif tool.startRot == tool.rotMin then
										rotTool.moveDownRot = "rotMax";
									else
										rotTool.moveDownRot = "rotMax";
									end;
								end;
								rotTool.rotatingToolIndex = i;
								table.insert(self.rotMovingTools, rotTool)
								break;
							end;
						end;
						if #self.rotMovingTools > 0 then
							self.isReelPresent = true;
							self.lastIsLowered = self:isLowered(true);
						end;
					end;
				self.reelAutoHeightFirstRun = nil;
			end;
			if self.isReelPresent then
				if self:isLowered(true) ~= self.lastIsLowered then
					if self:isLowered(true) then
						self.allowUpdateMovTool = true;
						self.moveToolDown = false;
					else
						self.allowUpdateMovTool = true;
						self.moveToolDown = true;
						for k,rotTool in pairs(self.rotMovingTools) do
							local tool = self.movingTools[rotTool.rotatingToolIndex]
							rotTool.desiredTargetRot = tool.curRot[tool.rotationAxis];
						end;
					end;
					self.lastIsLowered = self:isLowered(true);
				end;

				if self.allowUpdateMovTool then
					for k,rotTool in pairs(self.rotMovingTools) do
						local tool = self.movingTools[rotTool.rotatingToolIndex]
						if tool.rotSpeed ~= nil and rotTool.desiredTargetRot ~= nil then
							if self.moveToolDown then
								if rotTool.moveDownRot == "rotMax" then
									if tool.rotMax ~= nil and tool.curRot[tool.rotationAxis] < tool.rotMax then
										local changed = false;
										local newRot = tool.curRot[tool.rotationAxis]+tool.rotSpeed*dt;
										newRot = math.min(newRot, tool.rotMax);
										local diff = newRot - tool.curRot[tool.rotationAxis];
										if math.abs(diff) > 0 then
											tool.curRot[tool.rotationAxis] = newRot;
											setRotation(tool.node, unpack(tool.curRot));
											changed = true;
										end;
										if changed then
											Cylindered.setDirty(self, tool);
											self:raiseDirtyFlags(self.cylinderedDirtyFlag);
										end;
									else
										self.allowUpdateMovTool = false;
									end;
								elseif rotTool.moveDownRot == "rotMin" then
									if tool.rotMin ~= nil and tool.curRot[tool.rotationAxis] > tool.rotMin then
										local changed = false;
										local newRot = tool.curRot[tool.rotationAxis]-tool.rotSpeed*dt;
										newRot = math.max(newRot, tool.rotMin);
										local diff = newRot - tool.curRot[tool.rotationAxis];
										if math.abs(diff) > 0 then
											tool.curRot[tool.rotationAxis] = newRot;
											setRotation(tool.node, unpack(tool.curRot));
											changed = true;
										end;
										if changed then
											Cylindered.setDirty(self, tool);
											self:raiseDirtyFlags(self.cylinderedDirtyFlag);
										end;
									else
										self.allowUpdateMovTool = false;
									end;
								end;
							else
								if tool.curRot[tool.rotationAxis] < rotTool.desiredTargetRot then
									local changed = false;
									local newRot = tool.curRot[tool.rotationAxis]+tool.rotSpeed*dt;
									newRot = math.min(newRot, rotTool.desiredTargetRot);
									local diff = newRot - tool.curRot[tool.rotationAxis];
									if math.abs(diff) > 0 then
										tool.curRot[tool.rotationAxis] = newRot;
										setRotation(tool.node, unpack(tool.curRot));
										changed = true;
									end;
									if changed then
										Cylindered.setDirty(self, tool);
										self:raiseDirtyFlags(self.cylinderedDirtyFlag);
									end;
								elseif tool.curRot[tool.rotationAxis] > rotTool.desiredTargetRot then
									local changed = false;
									local newRot = tool.curRot[tool.rotationAxis]-tool.rotSpeed*dt;
									newRot = math.max(newRot, tool.rotMin);
									local diff = newRot - tool.curRot[tool.rotationAxis];
									if math.abs(diff) > 0 then
										tool.curRot[tool.rotationAxis] = newRot;
										setRotation(tool.node, unpack(tool.curRot));
										changed = true;
									end;
									if changed then
										Cylindered.setDirty(self, tool);
										self:raiseDirtyFlags(self.cylinderedDirtyFlag);
									end;
								else
									self.allowUpdateMovTool = false;
								end;
							end;
						end;
					end;
				end;
			end;
		end;
	end;
end;

function ReelAutoHeight:draw()
end;