-- CombineFillLevelWarnings
SpecializationUtil.registerSpecialization("combineFillLevelWarnings", "CoFiLeWa", g_currentModDirectory.."CombineFillLevelWarnings/CombineFillLevelWarnings.lua")

-- ThreshingCounter
SpecializationUtil.registerSpecialization("threshingCounter", "ThreshingCounter", g_currentModDirectory.."ThreshingCounter/ThreshingCounter.lua")

-- ReelAutoHeight
SpecializationUtil.registerSpecialization("reelAutoHeight", "ReelAutoHeight", g_currentModDirectory.."ReelAutoHeight/ReelAutoHeight.lua")

-- PipeUnloading
SpecializationUtil.registerSpecialization("pipeUnloading", "PipeUnloading", g_currentModDirectory.."PipeUnloading/PipeUnloading.lua")

BasisMOD_Register = {};

function BasisMOD_Register:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		
		print("--- loading CombineFillLevelWarnings - specialization by gotchTOM");	
		print("--- loading ThreshingCounter - specialization by Manuel Leithner / gotchTOM");	
		print("--- loading ReelAutoHeight - specialization to lift and lower the reel of the header automatically by gotchTOM");
		print("--- loading PipeUnloading - specialization by gotchTOM");	
		
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;

				-- CombineFillLevelWarnings, ThreshingCounter
				if SpecializationUtil.hasSpecialization(Combine, v.specializations) then
					local allowCombineFillLevelWarningsInsertion = true;
					local allowThreshingCounterInsertion = true;
					local v_name_string = v.name 
					local point_location = string.find(v_name_string, ".", nil, true)
					if point_location ~= nil then
						local _name = string.sub(v_name_string, 1, point_location-1);
						-- CombineFillLevelWarnings
						if rawget(SpecializationUtil.specializations, string.format("%s.combineFillLevelWarnings", _name)) ~= nil then
							allowCombineFillLevelWarningsInsertion = false;
							-- print(tostring(v.name)..": Specialization combineFillLevelWarnings is present! CombineFillLevelWarnings was not inserted!");
						end;
						if rawget(SpecializationUtil.specializations, string.format("%s.CombineFillLevelWarnings", _name)) ~= nil then
							allowCombineFillLevelWarningsInsertion = false;
							-- print(tostring(v.name)..": Specialization CombineFillLevelWarnings is present! CombineFillLevelWarnings was not inserted!");
						end;
						-- ThreshingCounter
						if rawget(SpecializationUtil.specializations, string.format("%s.threshingCounter", _name)) ~= nil then
							allowThreshingCounterInsertion = false;
							-- print(tostring(v.name)..": Specialization threshingCounter is present! ThreshingCounter was not inserted!");
						end;
						if rawget(SpecializationUtil.specializations, string.format("%s.ThreshingCounter", _name)) ~= nil then
							allowThreshingCounterInsertion = false;
							-- print(tostring(v.name)..": Specialization ThreshingCounter is present! ThreshingCounter was not inserted!");
						end;
					end;
					if allowCombineFillLevelWarningsInsertion then
						-- print("adding CombineFillLevelWarnings to:"..tostring(v.name));
						table.insert(v.specializations, SpecializationUtil.getSpecialization("combineFillLevelWarnings"));
					end;
					if allowThreshingCounterInsertion then
						-- print("adding ThreshingCounter to:"..tostring(v.name));
						table.insert(v.specializations, SpecializationUtil.getSpecialization("threshingCounter"));
					end;
				end;
				-- ReelAutoHeight
				if SpecializationUtil.hasSpecialization(Cutter, v.specializations) then 
					local allowReelAutoHeightInsertion = true;
					local v_name_string = v.name 
					local point_location = string.find(v_name_string, ".", nil, true)
					if point_location ~= nil then
						local _name = string.sub(v_name_string, 1, point_location-1);
						if rawget(SpecializationUtil.specializations, string.format("%s.reelAutoHeight", _name)) ~= nil then
							allowReelAutoHeightInsertion = false;								
						end;
						if rawget(SpecializationUtil.specializations, string.format("%s.ReelAutoHeight", _name)) ~= nil then
							allowReelAutoHeightInsertion = false;								
						end;														
					end;
					if allowReelAutoHeightInsertion then
						table.insert(v.specializations, SpecializationUtil.getSpecialization("reelAutoHeight"));
						-- print("adding reelAutoHeight to:"..tostring(v.name));											
					end;
				end;				
				-- PipeUnloading
				if SpecializationUtil.hasSpecialization(Overloading, v.specializations) and not SpecializationUtil.hasSpecialization(ConveyorBelt, v.specializations) and not SpecializationUtil.hasSpecialization(WoodCrusher, v.specializations) then
					local allowPipeUnloadingInsertion = true;
					local v_name_string = v.name 
					local point_location = string.find(v_name_string, ".", nil, true)
					if point_location ~= nil then
						local _name = string.sub(v_name_string, 1, point_location-1);
						if rawget(SpecializationUtil.specializations, string.format("%s.pipeUnloading", _name)) ~= nil then
							allowPipeUnloadingInsertion = false;								
						end;
						if rawget(SpecializationUtil.specializations, string.format("%s.PipeUnloading", _name)) ~= nil then
							allowPipeUnloadingInsertion = false;								
						end;														
					end;
					if allowPipeUnloadingInsertion then
						table.insert(v.specializations, SpecializationUtil.getSpecialization("pipeUnloading"));
						-- print("adding PipeUnloading to:"..tostring(v.name));											
					end;
				end;
			end;	
		end;
	end;
end;

function BasisMOD_Register:deleteMap()
  
end;

function BasisMOD_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function BasisMOD_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function BasisMOD_Register:update(dt)
	
end;

function BasisMOD_Register:draw()
  
end;

addModEventListener(BasisMOD_Register);